package com.inspur.gdrh.reportsasacdata.api;

package ..deTemp.1737690823875;

import com.alibaba.fastjson.JSON;
import com.inspur.gdrh.reportsasacdata.api.SyncGzwTreasuryServiceApi;
import com.inspur.gdrh.reportsasacdata.entity.agency.AgencyDto;
import com.inspur.gdrh.reportsasacdata.entity.agency.AgencyDtoSk;
import com.inspur.gdrh.reportsasacdata.entity.agency.AgencyListDto;
import com.inspur.gdrh.reportsasacdata.entity.debtserviceplan.DebtServicePlanDto;
import com.inspur.gdrh.reportsasacdata.entity.debtserviceplan.DebtServicePlanDtoSk;
import com.inspur.gdrh.reportsasacdata.entity.debtserviceplan.DebtServicePlanListDto;
import com.inspur.gdrh.reportsasacdata.entity.eventreport.EventReportDto;
import com.inspur.gdrh.reportsasacdata.entity.eventreport.EventReportDtoSk;
import com.inspur.gdrh.reportsasacdata.entity.eventreport.EventReportListDto;
import com.inspur.gdrh.reportsasacdata.entity.gzwreport.ReportDto;
import com.inspur.gdrh.reportsasacdata.entity.gzwreport.ReportDtoSk;
import com.inspur.gdrh.reportsasacdata.entity.gzwreport.ReportListDto;
import com.inspur.gdrh.reportsasacdata.entity.partnerDto.ResultPartner;
import com.inspur.gdrh.reportsasacdata.entity.payment.PaymentDto;
import com.inspur.gdrh.reportsasacdata.entity.payment.PaymentDtoSk;
import com.inspur.gdrh.reportsasacdata.entity.payment.PaymentListDto;
import com.inspur.gdrh.reportsasacdata.entity.register.RegisterDto;
import com.inspur.gdrh.reportsasacdata.entity.register.RegisterDtoSk;
import com.inspur.gdrh.reportsasacdata.entity.register.RegisterListDto;
import com.inspur.gdrh.reportsasacdata.entity.tjreportdata.GdrhTjjResponse;
import com.inspur.gdrh.reportsasacdata.entity.tjreportdata.GdrhTjjViewYdTjjjkbEntity;
import com.inspur.gdrh.reportsasacdata.entity.tjreportdata.GdrhTjjViewYdTjjjkbKey;
import com.inspur.gdrh.reportsasacdata.repository.AgencyDtoSkRepo;
import com.inspur.gdrh.reportsasacdata.repository.DebtServicePlanDtoSkRepo;
import com.inspur.gdrh.reportsasacdata.repository.EventReportDtoSkRepo;
import com.inspur.gdrh.reportsasacdata.repository.GdrhTjjViewYdTjjjkbRepo;
import com.inspur.gdrh.reportsasacdata.repository.PaymentDtoSkRepo;
import com.inspur.gdrh.reportsasacdata.repository.RegisterDtoSkRepo;
import com.inspur.gdrh.reportsasacdata.repository.ReportDtoSkRepo;
import com.inspur.gdrh.reportsasacdata.utils.DataBaseUtil;
import com.inspur.gdrh.reportsasacdata.utils.ReportUtils;
import com.inspur.gdrh.reportsasacdata.verifyData.manager.VerifyAgencyManager;
import com.inspur.gdrh.reportsasacdata.verifyData.manager.VerifyDebtServicePlanManager;
import com.inspur.gdrh.reportsasacdata.verifyData.manager.VerifyEventReportManager;
import com.inspur.gdrh.reportsasacdata.verifyData.manager.VerifyPaymentManager;
import com.inspur.gdrh.reportsasacdata.verifyData.manager.VerifyRegisterManager;
import com.inspur.gdrh.reportsasacdata.verifyData.manager.VerifyReportManager;
import io.iec.edp.caf.commons.utils.CollectionUtils;
import io.iec.edp.caf.commons.utils.SpringBeanUtils;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.text.SimpleDateFormat;
import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.Optional;
import java.util.Set;
import java.util.TreeMap;
import java.util.UUID;
import java.util.stream.Collectors;
import javax.persistence.EntityManager;
import javax.persistence.Query;
import org.apache.commons.lang3.StringUtils;
import org.hibernate.SQLQuery;
import org.hibernate.transform.ResultTransformer;
import org.hibernate.transform.Transformers;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class SyncGzwTreasuryServiceApiImpl implements SyncGzwTreasuryServiceApi {
  private static final Logger log = LoggerFactory.getLogger(com.inspur.gdrh.reportsasacdata.api.SyncGzwTreasuryServiceApiImpl.class);
  
  private final AgencyDtoSkRepo agencyDtoSkRepo = (AgencyDtoSkRepo)SpringBeanUtils.getBean(AgencyDtoSkRepo.class);
  
  private final DebtServicePlanDtoSkRepo debtServicePlanDtoSkRepo = (DebtServicePlanDtoSkRepo)SpringBeanUtils.getBean(DebtServicePlanDtoSkRepo.class);
  
  private final EventReportDtoSkRepo eventReportDtoSkRepo = (EventReportDtoSkRepo)SpringBeanUtils.getBean(EventReportDtoSkRepo.class);
  
  private final PaymentDtoSkRepo paymentDtoSkRepo = (PaymentDtoSkRepo)SpringBeanUtils.getBean(PaymentDtoSkRepo.class);
  
  private final RegisterDtoSkRepo registerDtoSkRepo = (RegisterDtoSkRepo)SpringBeanUtils.getBean(RegisterDtoSkRepo.class);
  
  private final ReportDtoSkRepo reportDtoSkRepo = (ReportDtoSkRepo)SpringBeanUtils.getBean(ReportDtoSkRepo.class);
  
  private final GdrhTjjViewYdTjjjkbRepo gdrhTjjViewYdTjjjkbRepo = (GdrhTjjViewYdTjjjkbRepo)SpringBeanUtils.getBean(GdrhTjjViewYdTjjjkbRepo.class);
  
  private final EntityManager entityManager;
  
  public SyncGzwTreasuryServiceApiImpl() {
    this.entityManager = (EntityManager)SpringBeanUtils.getBean(EntityManager.class);
  }
  
  public String zqzced(String data) {
    log.error("债券注册额度接口入参: {}", data);
    List<ResultPartner> resultList = new ArrayList<>();
    List<RegisterDto> datalist = null;
    try {
      RegisterListDto billDatas = (RegisterListDto)JSON.parseObject(data, RegisterListDto.class);
      datalist = billDatas.getDATALIST();
      if (CollectionUtils.isEmpty(datalist)) {
        ResultPartner result = new ResultPartner("E", "", "", "入参为空请检查!");
        resultList.add(result);
        return JSON.toJSONString(resultList);
      } 
    } catch (Throwable e) {
      log.error("e.getMessage: {}", e.getMessage());
      ResultPartner result = new ResultPartner("E", "", "", "入参格式异常请检查!");
      resultList.add(result);
      return JSON.toJSONString(resultList);
    } 
    try {
      List<RegisterDtoSk> registerDtoSks = new ArrayList<>();
      for (RegisterDto registerDto : datalist) {
        RegisterDtoSk registerDtoSk = new RegisterDtoSk(registerDto);
        StringBuffer dataMsg = new StringBuffer();
        VerifyRegisterManager.verify(registerDtoSk, dataMsg);
        if (StringUtils.isNotBlank(dataMsg.toString())) {
          ResultPartner result = new ResultPartner(registerDto.getSRCDOCID(), registerDto.getSOURCEID(), "E");
          result.setMESSAGE(dataMsg.toString());
          resultList.add(result);
          continue;
        } 
        registerDtoSk.setREASON("查验成功");
        registerDtoSk.setSTATUS("2");
        registerDtoSk.setSOURCETYPE("JK");
        Map<String, Object> idMap = DataBaseUtil.selectZqzcedExit(registerDto.getSOURCEID(), registerDto.getSRCDOCID());
        String exitid = (idMap.get("ID") == null) ? "" : idMap.get("ID").toString();
        String sasastatus = (idMap.get("SASACSTATUS") == null) ? "" : idMap.get("SASACSTATUS").toString();
        registerDtoSk.setID(UUID.randomUUID().toString());
        if (StringUtils.isNoneBlank(new CharSequence[] { exitid })) {
          if ("0".equals(sasastatus)) {
            ResultPartner result = new ResultPartner(registerDto.getSRCDOCID(), registerDto.getSOURCEID(), "E");
            result.setMESSAGE("该数据已发送国资委，且国资委还未引入，请删除数据后上传");
            resultList.add(result);
            continue;
          } 
          registerDtoSk.setID(exitid);
        } 
        registerDtoSks.add(registerDtoSk);
      } 
      this.registerDtoSkRepo.saveAll(registerDtoSks);
    } catch (Throwable throwable) {
      ResultPartner result = new ResultPartner("E", "", "", "保存数据异常," + throwable.getMessage());
      resultList.add(result);
    } 
    log.error("债券注册额度接口执行完成。");
    return JSON.toJSONString(resultList);
  }
  
  public String zqzjfw(String data) {
    log.error("债券中介服务机构接口入参: {}", data);
    List<ResultPartner> resultList = new ArrayList<>();
    List<AgencyDto> datalist = null;
    try {
      AgencyListDto billDatas = (AgencyListDto)JSON.parseObject(data, AgencyListDto.class);
      datalist = billDatas.getDATALIST();
      if (CollectionUtils.isEmpty(datalist)) {
        ResultPartner result = new ResultPartner("E", "", "", "入参为空请检查!");
        resultList.add(result);
        return JSON.toJSONString(resultList);
      } 
    } catch (Throwable e) {
      log.error("e.getMessage: {}", e.getMessage());
      ResultPartner result = new ResultPartner("E", "", "", "入参格式异常请检查!");
      resultList.add(result);
      return JSON.toJSONString(resultList);
    } 
    try {
      List<AgencyDtoSk> agencyDtoSks = new ArrayList<>();
      for (AgencyDto agencyDto : datalist) {
        AgencyDtoSk agencyDtoSk = new AgencyDtoSk(agencyDto);
        StringBuffer dataMsg = new StringBuffer();
        VerifyAgencyManager.verify(agencyDtoSk, dataMsg);
        if (StringUtils.isNotBlank(dataMsg.toString())) {
          ResultPartner result = new ResultPartner(agencyDto.getSRCDOCID(), agencyDto.getSOURCEID(), "E");
          result.setMESSAGE(dataMsg.toString());
          resultList.add(result);
          continue;
        } 
        agencyDtoSk.setREASON("查验成功");
        agencyDtoSk.setSTATUS("2");
        agencyDtoSk.setSOURCETYPE("JK");
        Map<String, Object> idMap = DataBaseUtil.selectZqzjfwExit(agencyDto.getSOURCEID(), agencyDto.getSRCDOCID());
        String exitid = (idMap.get("ID") == null) ? "" : idMap.get("ID").toString();
        String sasastatus = (idMap.get("SASACSTATUS") == null) ? "" : idMap.get("SASACSTATUS").toString();
        agencyDtoSk.setID(UUID.randomUUID().toString());
        if (StringUtils.isNoneBlank(new CharSequence[] { exitid })) {
          if ("0".equals(sasastatus)) {
            ResultPartner result = new ResultPartner(agencyDto.getSRCDOCID(), agencyDto.getSOURCEID(), "E");
            result.setMESSAGE("该数据已发送国资委，且国资委还未引入，请删除数据后上传");
            resultList.add(result);
            continue;
          } 
          agencyDtoSk.setID(exitid);
        } 
        agencyDtoSks.add(agencyDtoSk);
      } 
      this.agencyDtoSkRepo.saveAll(agencyDtoSks);
    } catch (Throwable throwable) {
      ResultPartner result = new ResultPartner("E", "", "", "保存数据异常," + throwable.getMessage());
      resultList.add(result);
    } 
    log.error("债券中介服务机构接口执行完成。");
    return JSON.toJSONString(resultList);
  }
  
  public String zqjdbg(String data) {
    log.error("债券季度报告接口入参: {}", data);
    List<ResultPartner> resultList = new ArrayList<>();
    List<ReportDto> datalist = null;
    try {
      ReportListDto billDatas = (ReportListDto)JSON.parseObject(data, ReportListDto.class);
      datalist = billDatas.getDATALIST();
      if (CollectionUtils.isEmpty(datalist)) {
        ResultPartner result = new ResultPartner("E", "", "", "入参为空请检查!");
        resultList.add(result);
        return JSON.toJSONString(resultList);
      } 
    } catch (Throwable e) {
      log.error("e.getMessage: {}", e.getMessage());
      ResultPartner result = new ResultPartner("E", "", "", "入参格式异常请检查!");
      resultList.add(result);
      return JSON.toJSONString(resultList);
    } 
    try {
      List<ReportDtoSk> reportDtoSks = new ArrayList<>();
      for (ReportDto reportDto : datalist) {
        ReportDtoSk reportDtoSk = new ReportDtoSk(reportDto);
        StringBuffer dataMsg = new StringBuffer();
        VerifyReportManager.verify(reportDtoSk, dataMsg);
        if (StringUtils.isNotBlank(dataMsg.toString())) {
          ResultPartner result = new ResultPartner(reportDto.getSRCDOCID(), reportDto.getSOURCEID(), "E");
          result.setMESSAGE(dataMsg.toString());
          resultList.add(result);
          continue;
        } 
        reportDtoSk.setREASON("查验成功");
        reportDtoSk.setSTATUS("2");
        reportDtoSk.setSOURCETYPE("JK");
        Map<String, Object> idMap = DataBaseUtil.selectZqjdbgExit(reportDto.getSOURCEID(), reportDto.getSRCDOCID());
        String exitid = (idMap.get("ID") == null) ? "" : idMap.get("ID").toString();
        String sasastatus = (idMap.get("SASACSTATUS") == null) ? "" : idMap.get("SASACSTATUS").toString();
        reportDtoSk.setID(UUID.randomUUID().toString());
        if (StringUtils.isNoneBlank(new CharSequence[] { exitid })) {
          if ("0".equals(sasastatus)) {
            ResultPartner result = new ResultPartner(reportDto.getSRCDOCID(), reportDto.getSOURCEID(), "E");
            result.setMESSAGE("该数据已发送国资委，且国资委还未引入，请删除数据后上传");
            resultList.add(result);
            continue;
          } 
          reportDtoSk.setID(exitid);
        } 
        reportDtoSks.add(reportDtoSk);
      } 
      this.reportDtoSkRepo.saveAll(reportDtoSks);
    } catch (Throwable throwable) {
      ResultPartner result = new ResultPartner("E", "", "", "保存数据异常," + throwable.getMessage());
      resultList.add(result);
    } 
    log.error("债券季度报告接口执行完成。");
    return JSON.toJSONString(resultList);
  }
  
  public String zqzdsxbg(String data) {
    log.error("债券重大事项报告接口入参: {}", data);
    List<ResultPartner> resultList = new ArrayList<>();
    List<EventReportDto> datalist = null;
    try {
      EventReportListDto billDatas = (EventReportListDto)JSON.parseObject(data, EventReportListDto.class);
      datalist = billDatas.getDATALIST();
      if (CollectionUtils.isEmpty(datalist)) {
        ResultPartner result = new ResultPartner("E", "", "", "入参为空请检查!");
        resultList.add(result);
        return JSON.toJSONString(resultList);
      } 
    } catch (Throwable e) {
      log.error("e.getMessage: {}", e.getMessage());
      ResultPartner result = new ResultPartner("E", "", "", "入参格式异常请检查!");
      resultList.add(result);
      return JSON.toJSONString(resultList);
    } 
    try {
      List<EventReportDtoSk> eventReportDtoSks = new ArrayList<>();
      for (EventReportDto eventReportDto : datalist) {
        EventReportDtoSk eventReportDtoSk = new EventReportDtoSk(eventReportDto);
        StringBuffer dataMsg = new StringBuffer();
        VerifyEventReportManager.verify(eventReportDtoSk, dataMsg);
        if (StringUtils.isNotBlank(dataMsg.toString())) {
          ResultPartner result = new ResultPartner(eventReportDto.getSRCDOCID(), eventReportDto.getSOURCEID(), "E");
          result.setMESSAGE(dataMsg.toString());
          resultList.add(result);
          continue;
        } 
        eventReportDtoSk.setREASON("查验成功");
        eventReportDtoSk.setSTATUS("2");
        eventReportDtoSk.setSOURCETYPE("JK");
        Map<String, Object> idMap = DataBaseUtil.selectZqzdsxbgExit(eventReportDto.getSOURCEID(), eventReportDto.getSRCDOCID());
        String exitid = (idMap.get("ID") == null) ? "" : idMap.get("ID").toString();
        String sasastatus = (idMap.get("SASACSTATUS") == null) ? "" : idMap.get("SASACSTATUS").toString();
        eventReportDtoSk.setID(UUID.randomUUID().toString());
        if (StringUtils.isNoneBlank(new CharSequence[] { exitid })) {
          if ("0".equals(sasastatus)) {
            ResultPartner result = new ResultPartner(eventReportDto.getSRCDOCID(), eventReportDto.getSOURCEID(), "E");
            result.setMESSAGE("该数据已发送国资委，且国资委还未引入，请删除数据后上传");
            resultList.add(result);
            continue;
          } 
          eventReportDtoSk.setID(exitid);
        } 
        eventReportDtoSks.add(eventReportDtoSk);
      } 
      this.eventReportDtoSkRepo.saveAll(eventReportDtoSks);
    } catch (Throwable throwable) {
      ResultPartner result = new ResultPartner("E", "", "", "保存数据异常," + throwable.getMessage());
      resultList.add(result);
    } 
    log.error("债券重大事项报告接口执行完成。");
    return JSON.toJSONString(resultList);
  }
  
  public String hbfxjhtb(String data) {
    log.error("还本付息计划表接口入参: {}", data);
    List<ResultPartner> resultList = new ArrayList<>();
    List<DebtServicePlanDto> datalist = null;
    try {
      DebtServicePlanListDto billDatas = (DebtServicePlanListDto)JSON.parseObject(data, DebtServicePlanListDto.class);
      datalist = billDatas.getDATALIST();
      if (CollectionUtils.isEmpty(datalist)) {
        ResultPartner result = new ResultPartner("E", "", "", "入参为空请检查!");
        resultList.add(result);
        return JSON.toJSONString(resultList);
      } 
    } catch (Throwable e) {
      log.error("e.getMessage: {}", e.getMessage());
      ResultPartner result = new ResultPartner("E", "", "", "入参格式异常请检查!");
      resultList.add(result);
      return JSON.toJSONString(resultList);
    } 
    try {
      List<DebtServicePlanDtoSk> debtServicePlanDtoSks = new ArrayList<>();
      for (DebtServicePlanDto debtServicePlanDto : datalist) {
        DebtServicePlanDtoSk debtServicePlanDtoSk = new DebtServicePlanDtoSk(debtServicePlanDto);
        StringBuffer dataMsg = new StringBuffer();
        VerifyDebtServicePlanManager.verify(debtServicePlanDtoSk, dataMsg);
        if (StringUtils.isNotBlank(dataMsg.toString())) {
          ResultPartner result = new ResultPartner(debtServicePlanDto.getSRCDOCID(), debtServicePlanDto.getSOURCEID(), "E");
          result.setMESSAGE(dataMsg.toString());
          resultList.add(result);
          continue;
        } 
        debtServicePlanDtoSk.setREASON("查验成功");
        debtServicePlanDtoSk.setSTATUS("2");
        debtServicePlanDtoSk.setSOURCETYPE("JK");
        Map<String, Object> idMap = DataBaseUtil.selectHbfxjhtbExit(debtServicePlanDto.getSOURCEID(), debtServicePlanDto.getSRCDOCID());
        String exitid = (idMap.get("ID") == null) ? "" : idMap.get("ID").toString();
        String sasastatus = (idMap.get("SASACSTATUS") == null) ? "" : idMap.get("SASACSTATUS").toString();
        debtServicePlanDtoSk.setID(UUID.randomUUID().toString());
        if (StringUtils.isNoneBlank(new CharSequence[] { exitid })) {
          if ("0".equals(sasastatus)) {
            ResultPartner result = new ResultPartner(debtServicePlanDto.getSRCDOCID(), debtServicePlanDto.getSOURCEID(), "E");
            result.setMESSAGE("该数据已发送国资委，且国资委还未引入，请删除数据后上传");
            resultList.add(result);
            continue;
          } 
          debtServicePlanDtoSk.setID(exitid);
        } 
        debtServicePlanDtoSks.add(debtServicePlanDtoSk);
      } 
      this.debtServicePlanDtoSkRepo.saveAll(debtServicePlanDtoSks);
    } catch (Throwable throwable) {
      ResultPartner result = new ResultPartner("E", "", "", "保存数据异常," + throwable.getMessage());
      resultList.add(result);
    } 
    log.error("还本付息计划表接口执行完成。");
    return JSON.toJSONString(resultList);
  }
  
  public String zqdfbg(String data) {
    log.error("债券兑付报告接口入参: {}", data);
    List<ResultPartner> resultList = new ArrayList<>();
    List<PaymentDto> datalist = null;
    try {
      PaymentListDto billDatas = (PaymentListDto)JSON.parseObject(data, PaymentListDto.class);
      datalist = billDatas.getDATALIST();
      if (CollectionUtils.isEmpty(datalist)) {
        ResultPartner result = new ResultPartner("E", "", "", "入参为空请检查!");
        resultList.add(result);
        return JSON.toJSONString(resultList);
      } 
    } catch (Throwable e) {
      log.error("e.getMessage: {}", e.getMessage());
      ResultPartner result = new ResultPartner("E", "", "", "入参格式异常请检查!");
      resultList.add(result);
      return JSON.toJSONString(resultList);
    } 
    try {
      List<PaymentDtoSk> paymentDtoSks = new ArrayList<>();
      for (PaymentDto paymentDto : datalist) {
        PaymentDtoSk paymentDtoSk = new PaymentDtoSk(paymentDto);
        StringBuffer dataMsg = new StringBuffer();
        VerifyPaymentManager.verify(paymentDtoSk, dataMsg);
        if (StringUtils.isNotBlank(dataMsg.toString())) {
          ResultPartner result = new ResultPartner(paymentDto.getSRCDOCID(), paymentDto.getSOURCEID(), "E");
          result.setMESSAGE(dataMsg.toString());
          resultList.add(result);
          continue;
        } 
        paymentDtoSk.setREASON("查验成功");
        paymentDtoSk.setSTATUS("2");
        paymentDtoSk.setSOURCETYPE("JK");
        Map<String, Object> idMap = DataBaseUtil.selectZqdfbgExit(paymentDto.getSOURCEID(), paymentDto.getSRCDOCID());
        String exitid = (idMap.get("ID") == null) ? "" : idMap.get("ID").toString();
        String sasastatus = (idMap.get("SASACSTATUS") == null) ? "" : idMap.get("SASACSTATUS").toString();
        paymentDtoSk.setID(UUID.randomUUID().toString());
        if (StringUtils.isNoneBlank(new CharSequence[] { exitid })) {
          if ("0".equals(sasastatus)) {
            ResultPartner result = new ResultPartner(paymentDto.getSRCDOCID(), paymentDto.getSOURCEID(), "E");
            result.setMESSAGE("该数据已发送国资委，且国资委还未引入，请删除数据后上传");
            resultList.add(result);
            continue;
          } 
          paymentDtoSk.setID(exitid);
        } 
        paymentDtoSks.add(paymentDtoSk);
      } 
      this.paymentDtoSkRepo.saveAll(paymentDtoSks);
    } catch (Throwable throwable) {
      ResultPartner result = new ResultPartner("E", "", "", "保存数据异常," + throwable.getMessage());
      resultList.add(result);
    } 
    log.error("债券兑付报告接口执行完成。");
    return JSON.toJSONString(resultList);
  }
  
  public String zqjdbgqsjs(Map<String, String> data) {
    Map<String, BigDecimal> decimalMap = new HashMap<>();
    decimalMap.put("LJYKCFBJ", BigDecimal.ZERO);
    decimalMap.put("LJYKCFLX", BigDecimal.ZERO);
    decimalMap.put("LJYFXWCFBQJ", BigDecimal.ZERO);
    decimalMap.put("YFXYJXJDXCHBJ", BigDecimal.ZERO);
    decimalMap.put("YFXYJWLYNXCHBJ", BigDecimal.ZERO);
    decimalMap.put("YYQBJ", BigDecimal.ZERO);
    decimalMap.put("YYQLX", BigDecimal.ZERO);
    decimalMap.put("SKFXED", BigDecimal.ZERO);
    String SQL4 = "SELECT SUM(HK.HBJE) as yzgje,jjnm FROM TMZQFXHKTZ HK WHERE  HK.YWFX=2 and YWRQ<='2999-12-31 00:00:00.000' AND HK.IFKZZ = '1' AND COALESCE(HK.ZXZT,0) <> -5 group by jjnm";
    String SQL3 = "SELECT sum(je) as fxje,jjnm from TMZQFXHKTZ where ywfx=1 and YWRQ<='2999-12-31 00:00:00.000' AND COALESCE(ZXZT,0) <> -5 and COALESCE(je,0)>0 group by jjnm";
    String SQL2 = "SELECT sum(hxje) as hxje,jjnm from TMZQFXHKTZ where ywfx=2 and YWRQ<='2999-12-31 00:00:00.000' AND COALESCE(ZXZT,0) <> -5 group by jjnm";
    String SQL1 = "select SUM(hbje) as hbje,jjnm FROM tmzqfxhktz WHERE ywfx=2 and YWRQ<='2999-12-31 00:00:00.000' AND (IFKZZ <>'1' or IFKZZ IS NULL) AND COALESCE(ZXZT,0) <> -5 group by jjnm";
    EntityManager entityManager = (EntityManager)SpringBeanUtils.getBean(EntityManager.class);
    Query query1 = entityManager.createNativeQuery(SQL1);
    Query query2 = entityManager.createNativeQuery(SQL2);
    Query query3 = entityManager.createNativeQuery(SQL3);
    Query query4 = entityManager.createNativeQuery(SQL4);
    List<Object[]> hbjelist = query1.getResultList();
    List<Object[]> hxjelist = query2.getResultList();
    List<Object[]> fxjelist = query3.getResultList();
    List<Object[]> yzgjelist = query4.getResultList();
    if (Objects.nonNull(data)) {
      String id = String.valueOf(data.get("ID"));
      String nf = String.valueOf(data.get("NF"));
      String jd = String.valueOf(data.get("JD"));
      String zqdm = String.valueOf(data.get("ZQDM"));
      if (StringUtils.isNoneBlank(new CharSequence[] { id })) {
        BigDecimal fxhbje = BigDecimal.ZERO;
        BigDecimal fxhxje = BigDecimal.ZERO;
        BigDecimal fxje = BigDecimal.ZERO;
        BigDecimal fxzgje = BigDecimal.ZERO;
        List<Object[]> hbList = (List<Object[]>)hbjelist.stream().filter(item -> id.equals(objectToString(item[1]))).collect(Collectors.toList());
        List<Object[]> hxList = (List<Object[]>)hxjelist.stream().filter(item -> id.equals(objectToString(item[1]))).collect(Collectors.toList());
        List<Object[]> jeList = (List<Object[]>)fxjelist.stream().filter(item -> id.equals(objectToString(item[1]))).collect(Collectors.toList());
        List<Object[]> zgList = (List<Object[]>)yzgjelist.stream().filter(item -> id.equals(objectToString(item[1]))).collect(Collectors.toList());
        if (hbList != null && hbList.size() > 0)
          fxhbje = objectToBigDecimal(((Object[])hbList.get(0))[0]); 
        if (hxList != null && hxList.size() > 0)
          fxhxje = objectToBigDecimal(((Object[])hxList.get(0))[0]); 
        if (jeList != null && jeList.size() > 0)
          fxje = objectToBigDecimal(((Object[])jeList.get(0))[0]); 
        if (zgList != null && zgList.size() > 0)
          fxzgje = objectToBigDecimal(((Object[])zgList.get(0))[0]); 
        if (fxhbje.compareTo(BigDecimal.ZERO) > 0)
          decimalMap.put("LJYKCFBJ", fxhbje); 
        if (fxhxje.compareTo(BigDecimal.ZERO) > 0)
          decimalMap.put("LJYKCFLX", fxhxje); 
        BigDecimal whbje = fxje.subtract(fxhbje).subtract(fxzgje);
        if (whbje.compareTo(BigDecimal.ZERO) > 0)
          decimalMap.put("LJYFXWCFBQJ", BigDecimal.ZERO); 
        String sql = "select TMZQHT.HTJE,TMZQFXHKTZ.ID,TMZQFXHKTZ.HTNM from TMZQFXHKTZ\n\t LEFT JOIN TMZQHT TMZQHT ON TMZQFXHKTZ.HTNM = TMZQHT.HTNM\n\t where id ='" + id + "' ";
        Query query5 = entityManager.createNativeQuery(sql);
        List htjelist = query5.getResultList();
        BigDecimal htje = objectToBigDecimal(((Object[])htjelist.get(0))[0]);
        String htnm = objectToString(((Object[])htjelist.get(0))[2]);
        BigDecimal skfxed = htje.subtract(fxje);
        if (skfxed.compareTo(BigDecimal.ZERO) > 0)
          decimalMap.put("SKFXED", skfxed); 
        if (StringUtils.isNoneBlank(new CharSequence[] { zqdm })) {
          sql = "select JHRQ, JHHXJE ,JHHBJE from TMZQHKJH where FXTZNM ='" + id + "' and JHHXJE > 0 and JHRQ < sysdate ORDER BY JHRQ ASC";
          Query query10 = entityManager.createNativeQuery(sql);
          List hkjhlist = query10.getResultList();
          int hkjhsize = (hkjhlist != null) ? hkjhlist.size() : 0;
          sql = "select YWRQ,HXJE from TMZQFXHKTZ where ZQDM = '" + zqdm + "' and HXJE > 0 and YWRQ < sysdate order by YWRQ ASC";
          Query query12 = entityManager.createNativeQuery(sql);
          List hktzlist = query12.getResultList();
          int hktzsize = (hktzlist != null) ? hktzlist.size() : 0;
          int minsize = (hktzsize > hkjhsize) ? hkjhsize : hktzsize;
          SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
          BigDecimal yuqilx = BigDecimal.ZERO;
          BigDecimal yuqije = BigDecimal.ZERO;
          for (int i = 0; i < minsize; i++) {
            String date01 = objectToString(((Object[])hkjhlist.get(i))[0]);
            String date02 = objectToString(((Object[])hktzlist.get(i))[0]);
            if (!StringUtils.isBlank(date01) && !StringUtils.isBlank(date02)) {
              String date01str = date01.substring(0, 10);
              String date02str = date02.substring(0, 10);
              if (!date01str.equals(date02str)) {
                Date date01d = null;
                Date date02d = null;
                try {
                  date01d = sdf.parse(date01str);
                  date02d = sdf.parse(date02str);
                } catch (Throwable e) {
                  log.error("时间转换错误，{} ,{}", date01str, date02str);
                } 
                if (!Objects.isNull(date01d) && !Objects.isNull(date02d))
                  if (date02d.after(date01d)) {
                    BigDecimal lixi = objectToBigDecimal(((Object[])hkjhlist.get(i))[1]);
                    BigDecimal hbje = objectToBigDecimal(((Object[])hkjhlist.get(i))[2]);
                    yuqilx = yuqilx.add(lixi);
                    yuqije = yuqije.add(yuqije);
                  }  
              } 
            } 
          } 
        } 
        if (StringUtils.isNoneBlank(new CharSequence[] { nf }) && StringUtils.isNoneBlank(new CharSequence[] { jd }))
          try {
            Map<String, Integer> integerMap = new HashMap<>();
            integerMap.put("01", Integer.valueOf(1));
            integerMap.put("02", Integer.valueOf(4));
            integerMap.put("03", Integer.valueOf(7));
            integerMap.put("04", Integer.valueOf(10));
            int i = Integer.valueOf(jd).intValue();
            int xjdint = i % 4 + 1;
            String xjd = "0" + xjdint;
            log.error("nf: {}", nf);
            int year = Integer.valueOf(nf).intValue();
            if ("04".equals(jd))
              year++; 
            int startYear = year;
            int endYear = year;
            int xstart = ((Integer)integerMap.get(xjd)).intValue();
            int startMonth = xstart;
            int endMonth = xstart + 2;
            String startDate = getFirstDayOfMonth(startYear, startMonth);
            String endDate = getLastDayOfMonth(endYear, endMonth);
            log.error("jd: {},{}", startDate, endDate);
            sql = "select sum( NVL(JHHXJE, 0)) AS sumJHHXJE ,sum(NVL(JHHBJE,0)) AS sumJHHBJE from TMZQHKJH where JHRQ >= '" + startDate + "' and JHRQ <= '" + endDate + "' group by FXTZNM having FXTZNM ='" + id + "'";
            Query query8 = entityManager.createNativeQuery(sql);
            List xjdlist = query8.getResultList();
            if (xjdlist != null && xjdlist.size() > 0) {
              BigDecimal xjdje = objectToBigDecimal(((Object[])xjdlist.get(0))[1]);
              decimalMap.put("YFXYJXJDXCHBJ", xjdje);
            } 
            startYear = year;
            endYear = ++year;
            endMonth = ((Integer)integerMap.get(jd)).intValue() + 2;
            startDate = getFirstDayOfMonth(startYear, startMonth);
            endDate = getLastDayOfMonth(endYear, endMonth);
            log.error("nd: {},{}", startDate, endDate);
            sql = "select sum( NVL(JHHXJE, 0)) AS sumJHHXJE ,sum(NVL(JHHBJE,0)) AS sumJHHBJE from TMZQHKJH where JHRQ >= '" + startDate + "' and JHRQ <= '" + endDate + "' group by FXTZNM having FXTZNM ='" + id + "'";
            Query query7 = entityManager.createNativeQuery(sql);
            List xnlist = query7.getResultList();
            if (xnlist != null && xnlist.size() > 0) {
              BigDecimal yuqije = objectToBigDecimal(((Object[])xnlist.get(0))[1]);
              decimalMap.put("YFXYJWLYNXCHBJ", yuqije);
            } 
          } catch (Throwable throwable) {
            log.error("时间转化错误: {}", throwable.getMessage());
            throwable.printStackTrace();
          }  
      } 
    } 
    Map<String, Object> map = new HashMap<>();
    map.put("success", Boolean.valueOf(true));
    map.put("data", decimalMap);
    return JSON.toJSONString(map);
  }
  
  public GdrhTjjResponse gdrhtjjreport(Map<String, Object> param) {
    log.error("调剂金接口取数开始");
    log.error("[GdZqGbdjyServiceImpl-getBlackfReportData]:删除调剂金监控报表数据开始");
    this.gdrhTjjViewYdTjjjkbRepo.deleteAllEntity();
    log.error("[GdZqGbdjyServiceImpl-getBlackfReportData]:删除调剂金监控报表数据完成");
    String startDate = param.containsKey("STARTDATE") ? String.valueOf(param.get("STARTDATE")) : "";
    String endDate = param.containsKey("ENDDATE") ? String.valueOf(param.get("ENDDATE")) : "";
    log.error(" startDate = {}, endDate = {}", startDate, endDate);
    List<GdrhTjjViewYdTjjjkbEntity> gdrhTjjViewYdTjjjkbEntities = new ArrayList<>();
    EntityManager entityManager = (EntityManager)SpringBeanUtils.getBean(EntityManager.class);
    if (StringUtils.isNoneBlank(new CharSequence[] { startDate }) && StringUtils.isNoneBlank(new CharSequence[] { endDate })) {
      String dw = param.containsKey("DW") ? String.valueOf(param.get("DW")) : "";
      String SQL = "select tms.ID,LOANUNIT AS  JCDWID,LOANUNITNAME AS JCDW,INTERIORADMINORG AS JRDWID,par.NAME_chs AS JRDW ,XM01 AS ISGQ,XM02 AS ISGJ,INTERIORCOMPANY ,VARIETIESNO from TMBANKLOANCONTRS tms\n  left join TMFINANCINGVARIETIES fins on tms.FINANCINGVARIETIES = fins.ID\n  left join BFPARTNER par on tms.CONSIGNOR = par.ID \n  where INTERIORCOMPANY = '1' and VARIETIESNO = 'W1402' ";
      if (StringUtils.isNoneBlank(new CharSequence[] { dw }))
        SQL = SQL + " and LOANUNIT = '" + dw + "'"; 
      Query query = entityManager.createNativeQuery(SQL);
      List<Object[]> dwList = query.getResultList();
      if (dwList != null && dwList.size() > 0) {
        log.error("借出条数  {} 条。", Integer.valueOf(dwList.size()));
        for (Object[] objects : dwList) {
          String id = objectToString(objects[0]);
          String jcdwid = objectToString(objects[1]);
          String jcdw = objectToString(objects[2]);
          String jrdwid = objectToString(objects[3]);
          String jrdw = objectToString(objects[4]);
          String isgq = objectToString(objects[5]);
          String isgj = objectToString(objects[6]);
          if (StringUtils.isBlank(jcdwid) || StringUtils.isBlank(jrdwid))
            continue; 
          GdrhTjjViewYdTjjjkbEntity gdrhTjjViewYdTjjjkbEntity = new GdrhTjjViewYdTjjjkbEntity();
          gdrhTjjViewYdTjjjkbEntity.setID(UUID.randomUUID().toString());
          gdrhTjjViewYdTjjjkbEntity.setJCDW(jcdwid);
          gdrhTjjViewYdTjjjkbEntity.setJRDW(jrdwid);
          SQL = "select sum(Nvl(LOANAMT,0)) AS LOANAMT,BANKLOANCONTRID from TMBANKLOANIOUS where BANKLOANCONTRID = '" + id + "' and loandate < '" + startDate + "' group by BANKLOANCONTRID";
          query = entityManager.createNativeQuery(SQL);
          List qctjjjelist = query.getResultList();
          if (qctjjjelist != null && qctjjjelist.size() > 0)
            gdrhTjjViewYdTjjjkbEntity.setQCTJJJE(objectToBigDecimal(((Object[])qctjjjelist.get(0))[0])); 
          SQL = "select sum(nvl(loanamt,0)) AS loanamt, bankloancontrid from TMBANKLOANIOUS where bankloancontrid = '" + id + "' and loandate >= '" + startDate + "' and loandate <= '" + endDate + "' group by bankloancontrid";
          query = entityManager.createNativeQuery(SQL);
          List bqzjeList = query.getResultList();
          if (bqzjeList != null && bqzjeList.size() > 0)
            gdrhTjjViewYdTjjjkbEntity.setBQZJE(objectToBigDecimal(((Object[])bqzjeList.get(0))[0])); 
          SQL = "select sum(nvl(rpaytprncplamt,0)) AS rpaytprncplamt, bankloancontrid from TMBANKLOANIOURPAYTS  where bankloancontrid = '" + id + "' and rpaytdate >= '" + startDate + "' and rpaytdate <= '" + endDate + "' group by bankloancontrid";
          query = entityManager.createNativeQuery(SQL);
          List bqjseList = query.getResultList();
          if (bqjseList != null && bqjseList.size() > 0)
            gdrhTjjViewYdTjjjkbEntity.setBQJSE(objectToBigDecimal(((Object[])bqjseList.get(0))[0])); 
          BigDecimal qctjjje = gdrhTjjViewYdTjjjkbEntity.getQCTJJJE();
          BigDecimal bqzje = gdrhTjjViewYdTjjjkbEntity.getBQZJE();
          BigDecimal bqjse = gdrhTjjViewYdTjjjkbEntity.getBQJSE();
          BigDecimal qmtjjje = qctjjje.add(bqzje).subtract(bqjse);
          gdrhTjjViewYdTjjjkbEntity.setQMTJJJE(qmtjjje);
          if ("1".equals(isgj)) {
            SQL = "select sum(nvl(loanamt,0)) AS loanamt, bankloancontrid from TMBANKLOANIOUS where bankloancontrid = '" + id + "' and loandate <= '" + endDate + "' group by bankloancontrid";
            query = entityManager.createNativeQuery(SQL);
            List mgfxjkjeList = query.getResultList();
            if (mgfxjkjeList != null && mgfxjkjeList.size() > 0)
              gdrhTjjViewYdTjjjkbEntity.setQMGFXJKJE(objectToBigDecimal(((Object[])mgfxjkjeList.get(0))[0])); 
          } 
          if ("1".equals(isgq))
            gdrhTjjViewYdTjjjkbEntity.setJRGFXQYJKJE(qmtjjje); 
          gdrhTjjViewYdTjjjkbEntities.add(gdrhTjjViewYdTjjjkbEntity);
        } 
      } 
    } else {
      log.error(" 日期未选择  startDate = {}, endDate = {}", startDate, endDate);
    } 
    List<Map<String, Object>> mapList = new ArrayList<>();
    ArrayList<GdrhTjjViewYdTjjjkbEntity> resultLists = new ArrayList<>();
    if (gdrhTjjViewYdTjjjkbEntities.size() > 0) {
      log.error("============相同借入借出合并开始===================");
      Map<GdrhTjjViewYdTjjjkbKey, GdrhTjjViewYdTjjjkbEntity> tjjMap = (Map<GdrhTjjViewYdTjjjkbKey, GdrhTjjViewYdTjjjkbEntity>)((Map)gdrhTjjViewYdTjjjkbEntities.stream().collect(Collectors.groupingBy(item -> new GdrhTjjViewYdTjjjkbKey(item.getJCDW(), item.getJRDW()), Collectors.reducing((a, b) -> new GdrhTjjViewYdTjjjkbEntity(a.getJCDW(), a.getJRDW(), a.getQCTJJJE().add(b.getQCTJJJE()), a.getBQZJE().add(b.getBQZJE()), a.getBQJSE().add(b.getBQJSE()), a.getQMTJJJE().add(b.getQMTJJJE()), a.getQMGFXJKJE().add(b.getQMGFXJKJE()), a.getJRGFXQYJKJE().add(b.getJRGFXQYJKJE()), a.getYSJCQYYSGFXJKYE().add(b.getYSJCQYYSGFXJKYE()), a.getYSJCQYYSGFXJKZGE().add(b.getYSJCQYYSGFXJKZGE()), a.getJQBYZCFZL().add(b.getJQBYZCFZL()), a.getJQNMJZC().add(b.getJQNMJZC()), a.getJQJCQYGMJZC().add(b.getJQJCQYGMJZC()), a.getJCQYNMJZC().add(b.getJCQYNMJZC()), a.getJCQYNMGMJZC().add(b.getJCQYNMGMJZC()), a.getJCQYDYJKBBJZCBL().add(b.getJCQYDYJKBBJZCBL())))))).entrySet().stream().collect(Collectors.toMap(Map.Entry::getKey, entry -> (GdrhTjjViewYdTjjjkbEntity)((Optional<GdrhTjjViewYdTjjjkbEntity>)entry.getValue()).orElse(null)));
      List<GdrhTjjViewYdTjjjkbEntity> tjjViewYdTjjjkbEntityList = new ArrayList<>(tjjMap.values());
      log.error("============相同借出借入合并完成=====");
      log.info("对借出单位与借入单位同时相同合并完成，合并后共  {} 条，此时借出和借入为一对一。", Integer.valueOf(tjjViewYdTjjjkbEntityList.size()));
      List<GdrhTjjViewYdTjjjkbEntity> tmpList = new ArrayList<>();
      log.error("============获取久其报表数据开始===================");
      String endYear = endDate.substring(0, 4);
      String startYear = String.valueOf(Integer.parseInt(endYear) - 3);
      log.error("利润总额 startYear {} , endYear {}", startYear, endYear);
      Map<String, Map<String, Object>> lrzeMap = setLrzeAmount(startYear, endYear);
      log.error("lrzeMap: {}", lrzeMap);
      for (GdrhTjjViewYdTjjjkbEntity gdrhTjjViewYdTjjjkbEntity1 : tjjViewYdTjjjkbEntityList) {
        String jcdw = gdrhTjjViewYdTjjjkbEntity1.getJCDW();
        String jrdw = gdrhTjjViewYdTjjjkbEntity1.getJRDW();
        String jcdworgCode = ReportUtils.getOrgCode(jcdw);
        String jrdworgCode = ReportUtils.getOrgCode(jrdw);
        if (StringUtils.isBlank(jcdworgCode) || StringUtils.isBlank(jrdworgCode))
          continue; 
        String jqjcCode = ReportUtils.getJqCode(jcdworgCode);
        String jqjrCode = ReportUtils.getJqCode(jrdworgCode);
        GdrhTjjViewYdTjjjkbEntity gdrhTjjViewEntity = new GdrhTjjViewYdTjjjkbEntity();
        gdrhTjjViewEntity.setID(gdrhTjjViewYdTjjjkbEntity1.getID());
        gdrhTjjViewEntity.setJCDW(jcdw);
        gdrhTjjViewEntity.setJRDW(jrdw);
        BigDecimal qctjjje = gdrhTjjViewYdTjjjkbEntity1.getQCTJJJE();
        gdrhTjjViewEntity.setQCTJJJE(qctjjje);
        BigDecimal bqzje = gdrhTjjViewYdTjjjkbEntity1.getBQZJE();
        gdrhTjjViewEntity.setBQZJE(bqzje);
        BigDecimal bqjse = gdrhTjjViewYdTjjjkbEntity1.getBQJSE();
        gdrhTjjViewEntity.setBQJSE(bqjse);
        BigDecimal qmtjjje = gdrhTjjViewYdTjjjkbEntity1.getQMTJJJE();
        gdrhTjjViewEntity.setQMTJJJE(qmtjjje);
        BigDecimal qmgfxjkje = gdrhTjjViewYdTjjjkbEntity1.getQMGFXJKJE();
        gdrhTjjViewEntity.setQMGFXJKJE(qmgfxjkje);
        BigDecimal jrgfxqyjkje = gdrhTjjViewYdTjjjkbEntity1.getJRGFXQYJKJE();
        gdrhTjjViewEntity.setJRGFXQYJKJE(jrgfxqyjkje);
        String year = endDate.substring(0, 4);
        String yearMonth = endDate.substring(0, 7);
        if (!StringUtils.isNoneBlank(new CharSequence[] { jqjcCode }) || !StringUtils.isNoneBlank(new CharSequence[] { jqjrCode }))
          log.error("借出单位编号 {}， 借入单位编号：{} 未转换成久其编码", jcdworgCode, jrdworgCode); 
        String jqsql = "select Nvl(PRINCIPALBALANCEAMOUNT,0) AS PRINCIPALBALANCEAMOUNT, nvl(LOANLIMITAMOUNT,0) AS LOANLIMITAMOUNT  from GDRHPADJUSTFUNDBUDGETREPORT where PROVIDELOANSORGCODE = '" + jcdworgCode + "' and LOANSORGCODE = '" + jrdworgCode + "' and YEAR = '" + year + "'";
        Query query = entityManager.createNativeQuery(jqsql);
        List jcqyysgfxjkyeList = query.getResultList();
        if (jcqyysgfxjkyeList != null && jcqyysgfxjkyeList.size() > 0) {
          gdrhTjjViewEntity.setYSJCQYYSGFXJKYE(objectToBigDecimal(((Object[])jcqyysgfxjkyeList.get(0))[0]));
          gdrhTjjViewEntity.setYSJCQYYSGFXJKZGE(objectToBigDecimal(((Object[])jcqyysgfxjkyeList.get(0))[1]));
        } 
        if (StringUtils.isNoneBlank(new CharSequence[] { jqjrCode })) {
          jqsql = "select nvl(LIABILITIESRATE,0) AS LIABILITIESRATE, ID from GDRHGMBALANCEREPORT where orgcode = '" + jqjrCode + "' and datatime = '" + yearMonth + "'";
          query = entityManager.createNativeQuery(jqsql);
          List jqbyzcfzlList = query.getResultList();
          if (jqbyzcfzlList != null && jqbyzcfzlList.size() > 0) {
            BigDecimal jqbyzcfzldata = objectToBigDecimal(((Object[])jqbyzcfzlList.get(0))[0]);
            BigDecimal finaljqbyzcfzl = jqbyzcfzldata.divide(BigDecimal.valueOf(100L), 3, RoundingMode.HALF_UP);
            gdrhTjjViewEntity.setJQBYZCFZL(finaljqbyzcfzl);
          } 
        } 
        int i = Integer.valueOf(year).intValue();
        log.error("i: {}", Integer.valueOf(i));
        int last = i - 1;
        log.error("last: {}", Integer.valueOf(last));
        String lastYear = String.valueOf(last);
        if (StringUtils.isNoneBlank(new CharSequence[] { jqjcCode })) {
          List jqjqnmjzcList = getjgList(entityManager, jqjcCode, lastYear);
          if (jqjqnmjzcList != null && jqjqnmjzcList.size() > 0) {
            gdrhTjjViewEntity.setJQNMJZC(objectToBigDecimal(((Object[])jqjqnmjzcList.get(0))[0]));
            gdrhTjjViewEntity.setJQJCQYGMJZC(objectToBigDecimal(((Object[])jqjqnmjzcList.get(0))[1]));
          } 
        } 
        BigDecimal lastJQNMJZC = gdrhTjjViewEntity.getJQNMJZC();
        BigDecimal lastJQJCQYGMJZC = gdrhTjjViewEntity.getJQJCQYGMJZC();
        if (lastJQNMJZC.compareTo(BigDecimal.ZERO) > 0 && 
          qmtjjje.compareTo(BigDecimal.ZERO) > 0) {
          gdrhTjjViewEntity.setJCQYNMJZC(qmtjjje.divide(lastJQNMJZC, 3, RoundingMode.HALF_UP));
          gdrhTjjViewEntity.setJCQYDYJKBBJZCBL(qmtjjje.divide(lastJQNMJZC, 3, RoundingMode.HALF_UP));
        } 
        if (lastJQJCQYGMJZC.compareTo(BigDecimal.ZERO) > 0 && 
          qmgfxjkje.compareTo(BigDecimal.ZERO) > 0)
          gdrhTjjViewEntity.setJCQYNMGMJZC(qmgfxjkje.divide(lastJQJCQYGMJZC, 3, RoundingMode.HALF_UP)); 
        BigDecimal SNLRZE = BigDecimal.ZERO;
        BigDecimal SSNLRZE = BigDecimal.ZERO;
        BigDecimal SSSNLRZE = BigDecimal.ZERO;
        BigDecimal SNJYXXJL = BigDecimal.ZERO;
        BigDecimal SSNJYXXJL = BigDecimal.ZERO;
        BigDecimal SSSNJYXXJL = BigDecimal.ZERO;
        if (lrzeMap.containsKey(jcdworgCode)) {
          SNLRZE = (((Map)lrzeMap.get(jcdworgCode)).get("SNLRZEAmount1") == null) ? BigDecimal.ZERO : new BigDecimal(((Map)lrzeMap.get(jcdworgCode)).get("SNLRZEAmount1").toString());
          SSNLRZE = (((Map)lrzeMap.get(jcdworgCode)).get("SNLRZEAmount2") == null) ? BigDecimal.ZERO : new BigDecimal(((Map)lrzeMap.get(jcdworgCode)).get("SNLRZEAmount2").toString());
          SSSNLRZE = (((Map)lrzeMap.get(jcdworgCode)).get("SNLRZEAmount3") == null) ? BigDecimal.ZERO : new BigDecimal(((Map)lrzeMap.get(jcdworgCode)).get("SNLRZEAmount3").toString());
          SNJYXXJL = (((Map)lrzeMap.get(jcdworgCode)).get("SNJYXXJLAmount1") == null) ? BigDecimal.ZERO : new BigDecimal(((Map)lrzeMap.get(jcdworgCode)).get("SNJYXXJLAmount1").toString());
          SSNJYXXJL = (((Map)lrzeMap.get(jcdworgCode)).get("SSNJYXXJLAmount2") == null) ? BigDecimal.ZERO : new BigDecimal(((Map)lrzeMap.get(jcdworgCode)).get("SSNJYXXJLAmount2").toString());
          SSSNJYXXJL = (((Map)lrzeMap.get(jcdworgCode)).get("SSSNJYXXJLAmount3") == null) ? BigDecimal.ZERO : new BigDecimal(((Map)lrzeMap.get(jcdworgCode)).get("SSSNJYXXJLAmount3").toString());
          gdrhTjjViewEntity.setSNLRZE(SNLRZE);
          gdrhTjjViewEntity.setSSNLRZE(SSNLRZE);
          gdrhTjjViewEntity.setSSSNLRZE(SSSNLRZE);
          gdrhTjjViewEntity.setSNJYXXJL(SNJYXXJL);
          gdrhTjjViewEntity.setSSNJYXXJL(SSNJYXXJL);
          gdrhTjjViewEntity.setSSSNJYXXJL(SSSNJYXXJL);
        } 
        tmpList.add(gdrhTjjViewEntity);
      } 
      log.error("========久其报表数据获取完成=========");
      log.error("=========对相同借出进行分组操作开始==================");
      Map<String, List<GdrhTjjViewYdTjjjkbEntity>> jcGroupMap = new HashMap<>();
      for (GdrhTjjViewYdTjjjkbEntity tjj : tmpList) {
        String jcdw = tjj.getJCDW();
        if (!jcGroupMap.containsKey(jcdw))
          jcGroupMap.put(jcdw, new ArrayList<>()); 
        ((List<GdrhTjjViewYdTjjjkbEntity>)jcGroupMap.get(jcdw)).add(tjj);
      } 
      log.error("对借出进行分组操作，分组后获得借出组数为 {} 组。", Integer.valueOf(jcGroupMap.size()));
      log.error("=====对相同借出进行分组操作完成=======");
      log.error("=============对借出分组进行合并操作开始===============");
      TreeMap<String, List<GdrhTjjViewYdTjjjkbEntity>> jcTreeMap = new TreeMap<>(jcGroupMap);
      GdrhTjjViewYdTjjjkbEntity gdrhTjjViewYdTjjjkbEntity = new GdrhTjjViewYdTjjjkbEntity();
      gdrhTjjViewYdTjjjkbEntity.setID(UUID.randomUUID().toString());
      gdrhTjjViewYdTjjjkbEntity.setXIAOJI("合计");
      gdrhTjjViewYdTjjjkbEntity.setJCDW("广东省广晟控股集团有限公司");
      resultLists.add(gdrhTjjViewYdTjjjkbEntity);
      BigDecimal allQCTJJJE = BigDecimal.ZERO;
      BigDecimal allBQZJE = BigDecimal.ZERO;
      BigDecimal allBQJSE = BigDecimal.ZERO;
      BigDecimal allQMTJJJE = BigDecimal.ZERO;
      BigDecimal allQMGFXJKJE = BigDecimal.ZERO;
      BigDecimal allJRGFXQYJKJE = BigDecimal.ZERO;
      BigDecimal allYSJCQYYSGFXJKYE = BigDecimal.ZERO;
      BigDecimal allYSJCQYYSGFXJKZGE = BigDecimal.ZERO;
      BigDecimal allJQBYZCFZL = BigDecimal.ZERO;
      BigDecimal allJQNMJZC = BigDecimal.ZERO;
      BigDecimal allJQJCQYGMJZC = BigDecimal.ZERO;
      BigDecimal allJCQYNMJZC = BigDecimal.ZERO;
      BigDecimal allJCQYNMGMJZC = BigDecimal.ZERO;
      BigDecimal allJCQYDYJKBBJZCBL = BigDecimal.ZERO;
      for (Map.Entry<String, List<GdrhTjjViewYdTjjjkbEntity>> entry : jcTreeMap.entrySet()) {
        String jcorgid = entry.getKey();
        List<GdrhTjjViewYdTjjjkbEntity> ydTjjjkbEntities = entry.getValue();
        if ("592344fb-f84d-ee16-97cd-0f358eb170e1".equals(jcorgid))
          log.error("单位合集：{}", JSON.toJSONString(ydTjjjkbEntities)); 
        if (ydTjjjkbEntities != null && ydTjjjkbEntities.size() > 0) {
          GdrhTjjViewYdTjjjkbEntity childentity = new GdrhTjjViewYdTjjjkbEntity();
          String jcorgname = ReportUtils.getOrgName(jcorgid);
          childentity.setID(UUID.randomUUID().toString());
          String replaceJcorgname = ((jcorgname.equals("广东省广晟控股集团有限公司") ? (jcorgname + "(本部)") : jcorgname) + "小计").replace("广东省", "").replace("有限公司", "");
          childentity.setXIAOJI(replaceJcorgname);
          childentity.setJCDW(jcorgname);
          resultLists.add(childentity);
          BigDecimal groupQCTJJJE = BigDecimal.ZERO;
          BigDecimal groupBQZJE = BigDecimal.ZERO;
          BigDecimal groupBQJSE = BigDecimal.ZERO;
          BigDecimal groupQMTJJJE = BigDecimal.ZERO;
          BigDecimal groupQMGFXJKJE = BigDecimal.ZERO;
          BigDecimal groupJRGFXQYJKJE = BigDecimal.ZERO;
          BigDecimal groupYSJCQYYSGFXJKYE = BigDecimal.ZERO;
          BigDecimal groupYSJCQYYSGFXJKZGE = BigDecimal.ZERO;
          BigDecimal groupJQBYZCFZL = BigDecimal.ZERO;
          BigDecimal groupJQNMJZC = BigDecimal.ZERO;
          BigDecimal groupJQJCQYGMJZC = BigDecimal.ZERO;
          BigDecimal groupJCQYNMJZC = BigDecimal.ZERO;
          BigDecimal groupJCQYNMGMJZC = BigDecimal.ZERO;
          BigDecimal groupJCQYDYJKBBJZCBL = BigDecimal.ZERO;
          for (GdrhTjjViewYdTjjjkbEntity ydTjjjkbEntity : ydTjjjkbEntities) {
            groupQCTJJJE = groupQCTJJJE.add(ydTjjjkbEntity.getQCTJJJE());
            groupBQZJE = groupBQZJE.add(ydTjjjkbEntity.getBQZJE());
            groupBQJSE = groupBQJSE.add(ydTjjjkbEntity.getBQJSE());
            BigDecimal qmtjjje = ydTjjjkbEntity.getQMTJJJE();
            groupQMTJJJE = groupQMTJJJE.add(qmtjjje);
            groupQMGFXJKJE = groupQMGFXJKJE.add(ydTjjjkbEntity.getQMGFXJKJE());
            groupJRGFXQYJKJE = groupJRGFXQYJKJE.add(ydTjjjkbEntity.getJRGFXQYJKJE());
            groupYSJCQYYSGFXJKYE = groupYSJCQYYSGFXJKYE.add(ydTjjjkbEntity.getYSJCQYYSGFXJKYE());
            groupYSJCQYYSGFXJKZGE = groupYSJCQYYSGFXJKZGE.add(ydTjjjkbEntity.getYSJCQYYSGFXJKZGE());
            groupJQBYZCFZL = groupJQBYZCFZL.add(ydTjjjkbEntity.getJQBYZCFZL());
            BigDecimal jqnmjzc = ydTjjjkbEntity.getJQNMJZC();
            groupJQNMJZC = groupJQNMJZC.add(jqnmjzc);
            groupJQJCQYGMJZC = groupJQJCQYGMJZC.add(ydTjjjkbEntity.getJQJCQYGMJZC());
            groupJCQYNMJZC = groupJCQYNMJZC.add(ydTjjjkbEntity.getJCQYNMJZC());
            groupJCQYNMGMJZC = groupJCQYNMGMJZC.add(ydTjjjkbEntity.getJCQYNMGMJZC());
            groupJCQYDYJKBBJZCBL = groupJCQYDYJKBBJZCBL.add(ydTjjjkbEntity.getJCQYDYJKBBJZCBL());
            String jcdwOrgName = ReportUtils.getOrgName(ydTjjjkbEntity.getJCDW());
            String jrdworgName = ReportUtils.getOrgName(ydTjjjkbEntity.getJRDW());
            BigDecimal heji = getHj(ydTjjjkbEntity.getJRDW(), ydTjjjkbEntities);
            log.error("{} 合计完成 {}", jrdworgName, heji);
            ydTjjjkbEntity.setJCDW(jcdwOrgName);
            if (jqnmjzc.compareTo(BigDecimal.ZERO) > 0)
              ydTjjjkbEntity.setJCQYDYJKBBJZCBL(heji.divide(jqnmjzc, 3, RoundingMode.HALF_UP)); 
            ydTjjjkbEntity.setID(UUID.randomUUID().toString());
            resultLists.add(ydTjjjkbEntity);
          } 
          childentity.setQCTJJJE(groupQCTJJJE);
          childentity.setBQZJE(groupBQZJE);
          childentity.setBQJSE(groupBQJSE);
          childentity.setQMTJJJE(groupQMTJJJE);
          childentity.setQMGFXJKJE(groupQMGFXJKJE);
          childentity.setJRGFXQYJKJE(groupJRGFXQYJKJE);
          childentity.setYSJCQYYSGFXJKYE(groupYSJCQYYSGFXJKYE);
          childentity.setYSJCQYYSGFXJKZGE(groupYSJCQYYSGFXJKZGE);
          childentity.setJQNMJZC(groupJQNMJZC);
          childentity.setJQJCQYGMJZC(groupJQJCQYGMJZC);
          childentity.setJCQYNMJZC(groupJCQYNMJZC);
          childentity.setJCQYNMGMJZC(groupJCQYNMGMJZC);
          childentity.setJCQYDYJKBBJZCBL(groupJCQYDYJKBBJZCBL);
          allQCTJJJE = allQCTJJJE.add(groupQCTJJJE);
          allBQZJE = allBQZJE.add(groupBQZJE);
          allBQJSE = allBQJSE.add(groupBQJSE);
          allQMTJJJE = allQMTJJJE.add(groupQMTJJJE);
          allQMGFXJKJE = allQMGFXJKJE.add(groupQMGFXJKJE);
          allJRGFXQYJKJE = allJRGFXQYJKJE.add(groupJRGFXQYJKJE);
          allYSJCQYYSGFXJKYE = allYSJCQYYSGFXJKYE.add(groupYSJCQYYSGFXJKYE);
          allYSJCQYYSGFXJKZGE = allYSJCQYYSGFXJKZGE.add(groupYSJCQYYSGFXJKZGE);
          allJQBYZCFZL = allJQBYZCFZL.add(groupJQBYZCFZL);
          allJQNMJZC = allJQNMJZC.add(groupJQNMJZC);
          allJQJCQYGMJZC = allJQJCQYGMJZC.add(groupJQJCQYGMJZC);
          allJCQYNMJZC = allJCQYNMJZC.add(groupJCQYNMJZC);
          allJCQYNMGMJZC = allJCQYNMGMJZC.add(groupJCQYNMGMJZC);
          allJCQYDYJKBBJZCBL = allJCQYDYJKBBJZCBL.add(groupJCQYDYJKBBJZCBL);
        } 
        gdrhTjjViewYdTjjjkbEntity.setQCTJJJE(allQCTJJJE);
        gdrhTjjViewYdTjjjkbEntity.setBQZJE(allBQZJE);
        gdrhTjjViewYdTjjjkbEntity.setBQJSE(allBQJSE);
        gdrhTjjViewYdTjjjkbEntity.setQMTJJJE(allQMTJJJE);
        gdrhTjjViewYdTjjjkbEntity.setQMGFXJKJE(allQMGFXJKJE);
        gdrhTjjViewYdTjjjkbEntity.setJRGFXQYJKJE(allJRGFXQYJKJE);
        gdrhTjjViewYdTjjjkbEntity.setYSJCQYYSGFXJKYE(allYSJCQYYSGFXJKYE);
        gdrhTjjViewYdTjjjkbEntity.setYSJCQYYSGFXJKZGE(allYSJCQYYSGFXJKZGE);
        gdrhTjjViewYdTjjjkbEntity.setJQNMJZC(allJQNMJZC);
        gdrhTjjViewYdTjjjkbEntity.setJQJCQYGMJZC(allJQJCQYGMJZC);
        gdrhTjjViewYdTjjjkbEntity.setJCQYNMJZC(allJCQYNMJZC);
        gdrhTjjViewYdTjjjkbEntity.setJCQYNMGMJZC(allJCQYNMGMJZC);
        gdrhTjjViewYdTjjjkbEntity.setJCQYDYJKBBJZCBL(allJCQYDYJKBBJZCBL);
      } 
      log.error("============对借出分组进行合并操作完成======");
    } 
    log.error("===========对数据进行Map转换操作=====================");
    if (resultLists.size() > 0) {
      for (GdrhTjjViewYdTjjjkbEntity resultList : resultLists) {
        String jrdw = resultList.getJRDW();
        if (StringUtils.isNoneBlank(new CharSequence[] { jrdw }))
          resultList.setJRDW(ReportUtils.getOrgName(jrdw)); 
      } 
      mapList = (List<Map<String, Object>>)resultLists.stream().map(p -> {
            Map<String, Object> map = new HashMap<>();
            map.put("ID", p.getID());
            map.put("JCDW", p.getJCDW());
            map.put("JRDW", p.getJRDW());
            map.put("QCTJJJE", p.getQCTJJJE());
            map.put("BQZJE", p.getBQZJE());
            map.put("BQJSE", p.getBQJSE());
            map.put("QMTJJJE", p.getQMTJJJE());
            map.put("QMGFXJKJE", p.getQMGFXJKJE());
            map.put("JRGFXQYJKJE", p.getJRGFXQYJKJE());
            map.put("YSJCQYYSGFXJKYE", p.getYSJCQYYSGFXJKYE());
            map.put("YSJCQYYSGFXJKZGE", p.getYSJCQYYSGFXJKZGE());
            map.put("JQBYZCFZL", p.getJQBYZCFZL());
            map.put("JQNMJZC", p.getJQNMJZC());
            map.put("JQJCQYGMJZC", p.getJQJCQYGMJZC());
            map.put("JCQYNMJZC", p.getJCQYNMJZC());
            map.put("JCQYNMGMJZC", p.getJCQYNMGMJZC());
            map.put("JCQYDYJKBBJZCBL", p.getJCQYDYJKBBJZCBL());
            map.put("XIAOJI", p.getXIAOJI());
            map.put("SNLRZE", p.getSNLRZE());
            map.put("SSNLRZE", p.getSSNLRZE());
            map.put("SSSNLRZE", p.getSSSNLRZE());
            map.put("SNJYXXJL", p.getSNJYXXJL());
            map.put("SSNJYXXJL", p.getSSNJYXXJL());
            map.put("SSSNJYXXJL", p.getSSSNJYXXJL());
            return map;
          }).collect(Collectors.toList());
      log.error("===========对数据进行Map转换操作完成======");
      log.error("=========对数据进行入表操作，后续导出===============");
      log.error("=========对数据进行入表操作，后续导出完成====");
    } 
    log.error("mapList {} ", Integer.valueOf(mapList.size()));
    log.error("调剂金接口取数完成");
    return GdrhTjjResponse.ok().setData(mapList);
  }
  
  public Map<String, Map<String, Object>> setLrzeAmount(String startYear, String endYear) {
    Map<String, Map<String, Object>> lrzeMap = new HashMap<>();
    String sql = "select ORGCODE,CASHFLOWAMOUNT,PROFITAMOUNT,YEAR from GDRHPROFITANDJYHDXJL where YEAR>=?1 and YEAR<?2";
    Query query = this.entityManager.createNativeQuery(sql).setParameter(1, startYear).setParameter(2, endYear);
    ((SQLQuery)query.unwrap(SQLQuery.class)).setResultTransformer((ResultTransformer)Transformers.ALIAS_TO_ENTITY_MAP);
    List<Map<String, Object>> res = query.getResultList();
    Map<String, List<Map<String, Object>>> map = (Map<String, List<Map<String, Object>>>)res.stream().collect(Collectors.groupingBy(o -> o.get("ORGCODE").toString()));
    log.debug("map={}", JSON.toJSONString(map));
    for (String keys : map.keySet()) {
      List<Map<String, Object>> item = map.get(keys);
      Map<String, Object> v = new HashMap<>();
      for (int i = 0; i < item.size(); i++) {
        Map<String, Object> value = item.get(i);
        String orgCode = value.get("ORGCODE").toString();
        String year = value.get("YEAR").toString();
        int num = Integer.parseInt(endYear) - Integer.parseInt(year);
        BigDecimal SNLRZEAmount = new BigDecimal(value.get("CASHFLOWAMOUNT").toString());
        String field = "SNLRZEAmount" + num;
        log.debug("field={}", field);
        BigDecimal SNJYXXJLAmount = new BigDecimal(value.get("PROFITAMOUNT").toString());
        String field2 = "SNJYXXJLAmount" + num;
        v.put(field, SNLRZEAmount);
        v.put(field2, SNJYXXJLAmount);
      } 
      lrzeMap.put(keys, v);
    } 
    log.debug("lrzeMap={}", JSON.toJSONString(lrzeMap));
    return lrzeMap;
  }
  
  private BigDecimal getHj(String jrdw, List<GdrhTjjViewYdTjjjkbEntity> ydTjjjkbEntities) {
    BigDecimal hj = BigDecimal.ZERO;
    Set<String> allids = getAllids(jrdw);
    allids.add(jrdw);
    for (GdrhTjjViewYdTjjjkbEntity ydTjjjkbEntity : ydTjjjkbEntities) {
      String jrdwid = ydTjjjkbEntity.getJRDW();
      if (allids.contains(jrdwid))
        hj = hj.add(ydTjjjkbEntity.getQMTJJJE()); 
    } 
    return hj;
  }
  
  public Set<String> getAllids(String jrdwid) {
    Set<String> ids = new HashSet<>();
    Set<String> xjDw = DataBaseUtil.getXjDw(jrdwid, "9edf25d1-b991-4dde-90b9-30145422d24d");
    for (String id : xjDw) {
      Set<String> dws = DataBaseUtil.getXjDw(id, "9edf25d1-b991-4dde-90b9-30145422d24d");
      if (dws.size() > 0)
        ids.addAll(dws); 
    } 
    Set<String> result = new HashSet<>();
    result.addAll(xjDw);
    if (ids.size() > 0)
      for (String id : ids) {
        Set<String> dws = DataBaseUtil.getXjDw(id, "9edf25d1-b991-4dde-90b9-30145422d24d");
        if (dws.size() > 0)
          result.addAll(dws); 
      }  
    return result;
  }
  
  private List getjgList(EntityManager entityManager, String jqjcCode, String year) {
    String jqsql = "select nvl(NETASSETSAMOUNT,0) AS NETASSETSAMOUNT, nvl(GMNETASSETSAMOUNT,0) AS GMNETASSETSAMOUNT  from GDRHFINALACCOUNTASSETQUERY where year = '" + year + "' and orgcode = '" + jqjcCode + "'";
    log.error("{} 决算资产查询表：jqsql: {}", jqjcCode, jqsql);
    Query query = entityManager.createNativeQuery(jqsql);
    List jqjqnmjzcList = query.getResultList();
    return jqjqnmjzcList;
  }
  
  public String getLastDayOfMonth(int year, int month) {
    LocalDate firstDayOfMonth = LocalDate.of(year, month, 1);
    LocalDate lastDayOfMonth = firstDayOfMonth.withDayOfMonth(firstDayOfMonth.lengthOfMonth());
    DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");
    return lastDayOfMonth.format(formatter);
  }
  
  public String getFirstDayOfMonth(int year, int month) {
    LocalDate firstDayOfMonth = LocalDate.of(year, month, 1);
    DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");
    return firstDayOfMonth.format(formatter);
  }
  
  public static BigDecimal objectToBigDecimal(Object obj) {
    return (obj == null) ? BigDecimal.ZERO : new BigDecimal(String.valueOf(obj));
  }
  
  public static String objectToString(Object obj) {
    return (obj == null) ? "" : String.valueOf(obj);
  }
}
